def union(f, g):
    h = dict()

    for x in f:
        h[x] = f[x]

    for x in g:
        if x in h:
            if h[x] != g[x]:
                raise KeyError('Conflict for key ' + str(x))
        h[x] = g[x]
    

    return h

def union(f, g):
    if any([f[x] != g[x] for x in set(f.keys()) & set(g.keys())]):
        raise KeyError('Conflict')
    return dict(list(f.items()) + list(g.items()))

def compose(f, g):
    h = dict()

    for x in f:
        y = f[x]
        if y in g:
            h[x] = g[y]

    return h

def compose(f, g):
    return dict([(x, g[f[x]]) for x in f if f[x] in g])



if __name__ == '__main__':
    f = {1 : 2, 2 : 4, 3 : 2}
    g = {2 : 4, 4 : 7}
    assert union(f, g) == {1 : 2, 2 : 4, 3 : 2, 4 : 7}
    assert compose(f, g) == {1 : 4, 2 : 7, 3 : 4}

    f = {1 : 2, 4 : 1}
    g = {1 : 3, 4 : 6}
    try:
        union(f, g)
        raise AssertionError()
    except KeyError:
        pass
    compose(f, g) == {4 : 3}
