def add(R, a, b):
    R.add((a,b))
    return R

def remove(R, a, b):
    if (a,b) in R:
        R.remove((a,b))
    return R

def map_element(R, a):
    bs = set()

    for (x,y) in R:
        if x == a:
            bs.add(y)

    return bs

def map_element(R, a):
    return set([y for (x,y) in R if x == a])

def inverse(R):
    P = set()
    for (x,y) in R:
        p.add((y,x))

    return P

def inverse(R):
    return set([(y,x) for (x,y) in R])

def compose(R, P):
    Q = set()
    for (x1,y1) in R:
        for (y2,z2) in P:
            if y1 == y2:
                Q.add((x1,z2))

    return Q

def merge(R, P):
    return R | P


if __name__ == '__main__':
    R = set([(1,'a'), (2,'b'), (1,'c'), (3,'a')])
    assert add(R, 1, 'c') == R
    assert add(R, 2, 'c') == set([(1,'a'), (2,'b'), (1,'c'), (3,'a'), (2,'c')])

    assert remove(R, 2, 'c') == set([(1,'a'), (2,'b'), (1,'c'), (3,'a')])
    assert remove(R, 2, 'c') == R

    R = set([(1,'a'), (2,'b'), (1,'c'), (3,'a')])
    assert map_element(R, 1) == set(['a', 'c'])
    assert map_element(R, 2) == set(['b'])
    assert map_element(R, 4) == set([])

    assert inverse(R) == set([('a',1), ('b',2), ('c',1), ('a',3)])

    P = set([('a',2), ('c',3)])
    
    assert compose(R, P) == set([(1,2), (1,3), (3,2)])

    assert merge(inverse(R), P) == set([('a',1), ('b',2), ('c',1), ('a',3), ('a',2), ('c',3)])
